> For the complete documentation index, see [llms.txt](https://docs.zircuit.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.zircuit.com/info/security/audit-reports.md).

# Audit Reports

**Security is the foundation of Zircuit's innovation.** We prioritize safeguarding our users and the integrity of our platform. In addition to conducting **rigorous internal audits** by our experts, we collaborate with **trusted, industry-leading external partners** to ensure our systems are secure against vulnerabilities. These external audits provide an additional layer of assurance, ensuring that Zircuit meets the highest standards of security and reliability in the Web3 ecosystem.

Here is the link to our audits: <https://github.com/zircuit-labs/audit-report/tree/main>

<table><thead><tr><th width="159">Auditor</th><th width="221">Description</th><th width="206">Audit Date</th><th>Report</th></tr></thead><tbody><tr><td>Quantstamp</td><td>L2 Upgradeable Contract</td><td>28 September 2024</td><td><a href="https://certificate.quantstamp.com/full/zircuit-l-2-upgradeable-contract/e765bc0e-0cbc-40f8-9a84-a7cfbd91cae0/index.html">Link</a></td></tr><tr><td>Quantstamp</td><td>Lido's wstETH</td><td>23 September 2024</td><td><a href="https://certificate.quantstamp.com/full/zircuit-lido-new-proposal/a8c75e25-29ae-4628-ab06-4c3a35123652/index.html">Link</a></td></tr><tr><td>Secure3</td><td>USDCAdapter</td><td>19 September 2024</td><td><a href="https://github.com/zircuit-labs/audit-report/blob/main/Zircuit-USDCAdapter_Secure3_Audit_Report-updated.pdf">Link</a></td></tr><tr><td>Secure3</td><td>Token and Migration</td><td>18 September 2024</td><td><a href="https://github.com/zircuit-labs/audit-report/blob/main/Zircuit_zrc_token_Secure3_Audit_Report.pdf">Link</a></td></tr><tr><td>Salus Security</td><td>Liquidity Hub</td><td>14 September 2024</td><td><a href="https://github.com/zircuit-labs/audit-report/blob/main/Zircuit-Labs_Zkr-Staking_report_2024-09-17.pdf">Link</a></td></tr><tr><td>Halborn</td><td>Token and Migration</td><td>2 August 2024</td><td><a href="https://github.com/zircuit-labs/audit-report/blob/main/Zircuit_Labs_zkr_staking_Migration_Contracts_Smart_Contract_Security.pdf">Link</a></td></tr><tr><td>Decurity</td><td>Token and Migration</td><td>31 July 2024</td><td><a href="https://github.com/zircuit-labs/audit-report/blob/main/Zircuit-ZRC-Token-audit-report-2024-1.1.pdf">Link</a></td></tr><tr><td>Dedaub</td><td>Bridge</td><td>24 July 2024</td><td><a href="https://github.com/zircuit-labs/audit-report/blob/main/Zircuit_OP_Bridge_July_24%2C_2024_Dedaub_Audit_Reports_gdoc.pdf">Link</a></td></tr><tr><td>Dedaub</td><td>Staking Pool</td><td>11 March 2024</td><td><a href="https://github.com/zircuit-labs/audit-report/blob/main/dedaub-audit-zkr-staking-ztakingpool.pdf">Link</a></td></tr><tr><td>OtterSec</td><td>Staking Pool</td><td>15 February 2024</td><td><a href="https://github.com/zircuit-labs/audit-report/blob/main/ztakingpool_ottersec.pdf">Link</a></td></tr></tbody></table>

### Acknowledged Issues

* `eth_call` , `eth_estimateGas` and similar rpc calls do not include the L1 fee in their estimation. This can lead to transactions succeeding on the rpc call that later fail due to insufficient funds. We recommend [manually computing the l1 fee](/info/architecture/gas-pricing-and-transaction-fees/l1-data-fee-calculation.md) when operating with low-balance accounts.

Last updated on 14 August, 2025


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.zircuit.com/info/security/audit-reports.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `build a script that syncs our docs to a CMS` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
